## librtech1 1.0.0

=== CMakeLists.txt ===
# -------------------------------------------------------
# r-tech1 cmake build script. Creates makefiles for unix
# based systems, cygwin(sp?) or mingw
#
# Written by: juvinious
# -------------------------------------------------------

# -------------------------------------------------------
# project name
# -------------------------------------------------------
project (r-tech1 C CXX)

# -------------------------------------------------------
# Ensure that we are doing an out of source build
# Prevents any mishaps
# Also remove the makefile to regenerate the filelist
# -------------------------------------------------------
cmake_minimum_required(VERSION 2.6)
if(EXISTS ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
	file(REMOVE ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
	file(REMOVE_RECURSE ${CMAKE_SOURCE_DIR}/CMakeFiles)
endif(EXISTS ${CMAKE_SOURCE_DIR}/CMakeCache.txt)
if(EXISTS ${CMAKE_BINARY_DIR}/Makefile)
	file(REMOVE ${CMAKE_BINARY_DIR}/Makefile)
endif(EXISTS ${CMAKE_BINARY_DIR}/Makefile)
if(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	if(UNIX AND NOT CYGWIN)
		message(FATAL_ERROR "Oops. Don't do an in-source build. Create an extra directory change into it and run cmake pointing to the base directory. IE: \nmkdir mybuild && cd mybuild && cmake ../ && make\nYou may need to remove CMakeCache.txt and the CMakeFiles directory in ${CMAKE_SOURCE_DIR} if you can't get rid of this error.")
	else(UNIX AND NOT CYGWIN)
		message(FATAL_ERROR "Oops. Don't do an in-source build. Create an extra directory change into it and run cmake pointing to the base directory. IE: \nmkdir mybuild; cd mybuild; cmakesetup ../\nYou may need to remove CMakeCache.txt and the CMakeFiles directory in  ${CMAKE_SOURCE_DIR} if you can't get rid of this error.")
	endif(UNIX AND NOT CYGWIN)
endif(${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})

# -------------------------------------------------------
# Output directories
# -------------------------------------------------------
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/bin)

# -------------------------------------------------------
# Directory in which extra macros can be found
# -------------------------------------------------------
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# -------------------------------------------------------
# Add in uninstall target
# -------------------------------------------------------
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

# -------------------------------------------------------
# Including needed macros
# -------------------------------------------------------
include(UseLLVM)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
find_package(ZLIB)
find_package(PNG)
find_package(FREETYPE)
find_package(Threads)
#find_package(GNUREGEX)
find_package(VORBIS)
find_package(OGG)
find_package(MPG123)

# -------------------------------------------------------
# Include Source
# -------------------------------------------------------
mark_as_advanced(CLEAR ZLIB_INCLUDE_DIR)
mark_as_advanced(CLEAR ZLIB_LIBRARY)

mark_as_advanced(CLEAR PNG_PNG_INCLUDE_DIR)
mark_as_advanced(CLEAR PNG_LIBRARY)

# -------------------------------------------------------
# User setable options
# -------------------------------------------------------
option(DEBUG "Compile r-tech1 with debug information?" OFF)

if($ENV{DEBUG})
    set(DEBUG ON)
elseif(NOT $ENV{DEBUG})
    set(DEBUG OFF)
endif($ENV{DEBUG})

if(DEBUG)
    add_definitions(-DDEBUG)
    if(USE_LLVM)
        set(CMAKE_CXX_FLAGS "-Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -Woverloaded-virtual -g3 -ggdb")
        set(CMAKE_C_FLAGS "-Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -g3 -ggdb")
    else(USE_LLVM)
        set(CMAKE_CXX_FLAGS "-Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -fexpensive-optimizations -Woverloaded-virtual -g3 -ggdb")
        set(CMAKE_C_FLAGS "-Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -fexpensive-optimizations -g3 -ggdb")
    endif(USE_LLVM)
else(DEBUG)
    if(USE_LLVM)
        set(CMAKE_CXX_FLAGS "-O2 -Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -Woverloaded-virtual")
        set(CMAKE_C_FLAGS "-O2 -Wall -Wno-unused-variable -Wno-unused-function -funroll-loops")
    else(USE_LLVM)
        set(CMAKE_CXX_FLAGS "-O2 -Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -fexpensive-optimizations -Woverloaded-virtual")
        set(CMAKE_C_FLAGS "-O2 -Wall -Wno-unused-variable -Wno-unused-function -funroll-loops -fexpensive-optimizations")
    endif(USE_LLVM)
endif(DEBUG)
    
# Networking
add_definitions(-DHAVE_NETWORKING)

add_definitions(-DHAVE_CXX11 -DDUMB_DECLARE_DEPRECATED)

option(USE_ALLEGRO5 "Compile r-tech1 with ALLEGRO 5 instead of SDL or Allegro 4.x?" ON)

if($ENV{ALLEGRO5})
    set(USE_ALLEGRO5 ON)
elseif(NOT $ENV{ALLEGRO5})
    set(USE_ALLEGRO5 OFF)
endif($ENV{ALLEGRO5})

if(OGG_FOUND)
    add_definitions(-DHAVE_OGG)
    set(OGG_LIBS ${OGG_LIBRARY} ${VORBIS_LIBRARIES})
    set(OGG_INCLUDES ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})
else(OGG_FOUND)
    set(OGG_LIBS "")
    set(OGG_INCLUDES "")
endif(OGG_FOUND)

# Allegro5
find_package(ALLEGRO5)
if(NOT ALLEGRO_FOUND)
message(FATAL_ERROR "Couldn't find Allegro 5 and/or a required Allegro 5 module")
endif(NOT ALLEGRO_FOUND)
set(GRAPHICS_LIBRARIES ${ALLEGRO_LIBRARIES})
set(GRAPHICS_INCLUDES ${ALLEGRO_INCLUDE_DIR})

if(MPG123_FOUND)
    add_definitions(-DHAVE_MP3_MPG123)
    set(MP3_LIBS ${MPG123_LIBRARY})
    set(MP3_INCLUDES ${MPG123_INCLUDE_DIR})
else(MPG123_FOUND)
    if (SDL_FOUND)
	# Try looking for libmad instead only if SDL is available
	find_package(MAD)
	if (MAD_FOUND)
	    add_definitions(-DHAVE_MP3_MAD)
	    set(MP3_LIBS ${MAD_LIBRARY})
	    set(MP3_INCLUDES ${MAD_INCLUDE_DIR})
	else(MAD_FOUND)
	    set(MP3_LIBS "")
	    set(MP3_INCLUDES "")
	endif(MAD_FOUND)
    endif (SDL_FOUND)
endif(MPG123_FOUND)

# freetype
if(NOT FREETYPE_FOUND)
	message(FATAL_ERROR "Couldn't find freetype")
endif(NOT FREETYPE_FOUND)

# -------------------------------------------------------
# Paths and system setup
# -------------------------------------------------------

# -------------------------------------------------------
# MINGW
# -------------------------------------------------------

if(MINGW OR CYGWIN)
	# -------------------------------------------------------
	# Take those user options and set the necessary compile time preprocessors
	# -------------------------------------------------------
	add_definitions(-DWINDOWS)
	set(WIN_LIB -lgdi32 -luser32 -lwsock32)
	 set(CMAKE_THREAD_LIBS_INIT -lpthreadGC2)
else(MINGW OR CYGWIN)
	 set(CMAKE_THREAD_LIBS_INIT -lpthread)
endif(MINGW OR CYGWIN)

# -------------------------------------------------------
# Apple OSX
# -------------------------------------------------------

if(APPLE)
	# -------------------------------------------------------
    # Added stuff for osx
	# -------------------------------------------------------
	set(WIN_LIB "-framework Carbon")
	add_definitions(-DMACOSX)
        
        # Groups
        set(GROUP_START "-Wl,-all_load")
        set(GROUP_END "")
else(APPLE)
        # Groups
        set(GROUP_START "-Wl,--start-group")
        set(GROUP_END "-Wl,--end-group")
endif(APPLE)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
include_directories(src src/libs src/libs/hawknl src/libs/dumb/include include ${GRAPHICS_INCLUDES} ${FREETYPE_INCLUDE_DIR} ${OGG_INCLUDES} ${MP3_INCLUDES})

# -------------------------------------------------------
# Put the linked libraries together
# -------------------------------------------------------
set(REQUIRED_LIBS ${GRAPHICS_LIBRARIES}  ${CMAKE_THREAD_LIBS_INIT} ${FREETYPE_LIBRARIES} ${PNG_LIBRARY} ${ZLIB_LIBRARY} ${OGG_LIBS} ${MP3_LIBS} ${WIN_LIB} ${WINSOCK})

# -------------------------------------------------------
# Source files
# -------------------------------------------------------

#Base Source
add_subdirectory(${CMAKE_SOURCE_DIR}/src)

# 7z
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/7z)

#Dumb
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/dumb)

#Hawknl
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/hawknl)

#Minizip
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/zip)

# SFL
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/sfl)

# GME Library
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/gme)

# PCRE
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/pcre)

# LZ4
add_subdirectory(${CMAKE_SOURCE_DIR}/src/libs/lz4)

# Create r-tech1 library
add_library(r-tech1 ${SFL_SRC} ${UTIL_SRC} ${PCRE_SRC} ${x7Z_SRC} ${DUMB_SRC} ${MINIZIP_SRC} ${HAWKNL_SRC} ${GME_SRC} ${LZ4_SRC})

# Init test
add_executable(init-test tests/init/main.cpp)
target_link_libraries(init-test r-tech1 ${REQUIRED_LIBS})

# Install
install (TARGETS r-tech1 DESTINATION lib)
install (DIRECTORY ${CMAKE_SOURCE_DIR}/include/r-tech1 DESTINATION include)

# Pkgconfig
if(UNIX OR LINUX OR CYGWIN OR MINGW)
    if(DEBUG)
        set(lib "r-tech1-debug")
        set(libs
            "allegro-debug-5 allegro_ttf-debug-5 allegro_memfile-debug-5 allegro_image-debug-5 allegro_primitives-debug-5 allegro_audio-debug-5 allegro_acodec-debug-5 freetype2 zlib")
    else(DEBUG)
        set(lib "r-tech1")
        set(libs
            "allegro-5 allegro_ttf-5 allegro_memfile-5 allegro_image-5 allegro_primitives-5 allegro_audio-5 allegro_acodec-5 freetype2 zlib")
    endif(DEBUG)
    set(prefix ${CMAKE_INSTALL_PREFIX})
    set(rtech1_version "1")
    configure_file(${CMAKE_SOURCE_DIR}/misc/r-tech1.pc.in ${LIBRARY_OUTPUT_PATH}/pkgconfig/${lib}.pc @ONLY)
    install(FILES ${LIBRARY_OUTPUT_PATH}/pkgconfig/${lib}.pc DESTINATION lib/pkgconfig)
endif(UNIX OR LINUX OR CYGWIN OR MINGW)

=== Makefile ===
all:
	@scons

clean:
	@scons -c

install:
	@scons install

=== SConstruct ===
import os
import scons_rtech1.utils
import scons_rtech1.checks
import scons_rtech1.env

SetOption('num_jobs', scons_rtech1.utils.detectCPUs())

# FIXME: use Dir('.').rel_path(Dir('#"))
includedir = '{0}/include'.format(os.getcwd())

env = Environment(ENV = os.environ, CPPPATH=includedir, tools=['textfile', 'default'])

if scons_rtech1.utils.useAndroid():
    env = scons.env.android(env)
if scons_rtech1.utils.useAndroidX64():
    env = scons.env.androidx64(env)

if not scons_rtech1.utils.isVerbose():
    env = scons_rtech1.utils.less_verbose(env)

root = '.'
build_dir_root = 'build'
env.Default(SConscript('SConscript', exports = ['env', 'root', 'build_dir_root']))

=== src/CMakeLists.txt ===
# -------------------------------------------------------
# util cmake build script for r-tech1.
# Written by: juvinious
# Modified by: kazzmir
# -------------------------------------------------------
project (util C CXX)

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
set(UTIL_SRC
${CMAKE_CURRENT_SOURCE_DIR}/argument.cpp
${CMAKE_CURRENT_SOURCE_DIR}/configuration.cpp
${CMAKE_CURRENT_SOURCE_DIR}/network/network.cpp
${CMAKE_CURRENT_SOURCE_DIR}/network/chat.cpp
${CMAKE_CURRENT_SOURCE_DIR}/network/irc.cpp
${CMAKE_CURRENT_SOURCE_DIR}/token.cpp
${CMAKE_CURRENT_SOURCE_DIR}/resource.cpp
${CMAKE_CURRENT_SOURCE_DIR}/tokenreader.cpp
${CMAKE_CURRENT_SOURCE_DIR}/timedifference.cpp
${CMAKE_CURRENT_SOURCE_DIR}/debug.cpp
${CMAKE_CURRENT_SOURCE_DIR}/timer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/init.cpp
${CMAKE_CURRENT_SOURCE_DIR}/utf.cpp
${CMAKE_CURRENT_SOURCE_DIR}/console.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/keyboard.cpp
${CMAKE_CURRENT_SOURCE_DIR}/loading.cpp
${CMAKE_CURRENT_SOURCE_DIR}/messages.cpp
${CMAKE_CURRENT_SOURCE_DIR}/graphics/bitmap.cpp
${CMAKE_CURRENT_SOURCE_DIR}/graphics/image.cpp
${CMAKE_CURRENT_SOURCE_DIR}/events.cpp
${CMAKE_CURRENT_SOURCE_DIR}/font.cpp
${CMAKE_CURRENT_SOURCE_DIR}/font_factory.cpp
${CMAKE_CURRENT_SOURCE_DIR}/graphics/fire.cpp
${CMAKE_CURRENT_SOURCE_DIR}/ftalleg.cpp
${CMAKE_CURRENT_SOURCE_DIR}/funcs.cpp
${CMAKE_CURRENT_SOURCE_DIR}/directory.cpp
${CMAKE_CURRENT_SOURCE_DIR}/file-system.cpp
${CMAKE_CURRENT_SOURCE_DIR}/graphics/gradient.cpp
${CMAKE_CURRENT_SOURCE_DIR}/ebox.cpp
${CMAKE_CURRENT_SOURCE_DIR}/regex.cpp
${CMAKE_CURRENT_SOURCE_DIR}/language-string.cpp
${CMAKE_CURRENT_SOURCE_DIR}/thread.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/text-input.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/input-manager.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/input-source.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/joystick.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/allegro5/joystick.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/touch.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/allegro5/touch.cpp
${CMAKE_CURRENT_SOURCE_DIR}/xenon/xenon.cpp
${CMAKE_CURRENT_SOURCE_DIR}/system.cpp
${CMAKE_CURRENT_SOURCE_DIR}/version.cpp
${CMAKE_CURRENT_SOURCE_DIR}/compress.cpp
${CMAKE_CURRENT_SOURCE_DIR}/message-queue.cpp
${CMAKE_CURRENT_SOURCE_DIR}/input/linux_joystick.cpp
${CMAKE_CURRENT_SOURCE_DIR}/exceptions/load_exception.cpp
${CMAKE_CURRENT_SOURCE_DIR}/windows/system.cpp
${CMAKE_CURRENT_SOURCE_DIR}/nacl/module.cpp
${CMAKE_CURRENT_SOURCE_DIR}/nacl/network-system.cpp
${CMAKE_CURRENT_SOURCE_DIR}/exceptions/exception.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/actionfactory.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/action_speed.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/menu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/font-info.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/menu_action.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/menu_option.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/options.cpp
${CMAKE_CURRENT_SOURCE_DIR}/menu/optionfactory.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/animation.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/box.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/container.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/context-box.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/coordinate.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/cutscene.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/fadetool.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/lineedit.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/list.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/rectarea.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/popup-box.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/scroll-list.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/select-list.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/tab-container.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/tabbed-box.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/timer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gui/widget.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sound/sound.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sound/audio.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sound/music-player.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sound/music-renderer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/sound/music.cpp
${CMAKE_CURRENT_SOURCE_DIR}/system/timer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/system/allegro5/timer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/system/allegro5/init.cpp
PARENT_SCOPE)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
#include_directories(include include/internal)

# -------------------------------------------------------
# module
# -------------------------------------------------------
# add_library (util_module ${UTIL_SRC})

=== src/libs/7z/CMakeLists.txt ===
# -------------------------------------------------------
# util cmake build script for r-tech1.
# Written by: juvinious
# Modified by: kazzmir
# -------------------------------------------------------

project (x7z C CXX)

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
set(x7Z_SRC
${CMAKE_CURRENT_SOURCE_DIR}/7zAlloc.c
${CMAKE_CURRENT_SOURCE_DIR}/7zBuf.c
${CMAKE_CURRENT_SOURCE_DIR}/7zBuf2.c
${CMAKE_CURRENT_SOURCE_DIR}/7zCrc.c
${CMAKE_CURRENT_SOURCE_DIR}/7zCrcOpt.c
${CMAKE_CURRENT_SOURCE_DIR}/7zDec.c
${CMAKE_CURRENT_SOURCE_DIR}/7zIn.c
${CMAKE_CURRENT_SOURCE_DIR}/CpuArch.c
${CMAKE_CURRENT_SOURCE_DIR}/LzmaDec.c
${CMAKE_CURRENT_SOURCE_DIR}/Lzma2Dec.c
${CMAKE_CURRENT_SOURCE_DIR}/Bra.c
${CMAKE_CURRENT_SOURCE_DIR}/Bra86.c
${CMAKE_CURRENT_SOURCE_DIR}/Bcj2.c
${CMAKE_CURRENT_SOURCE_DIR}/7zFile.c
${CMAKE_CURRENT_SOURCE_DIR}/7zStream.c
PARENT_SCOPE)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
#include_directories(include include/internal)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (x7z_module ${x7Z_SRC})


# Install
file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/r-tech1/libs/7z)

=== src/libs/dumb/CMakeLists.txt ===
# -------------------------------------------------------
# dumb cmake build script for r-tech1.
# Written by: juvinious
# -------------------------------------------------------
project (dumb C)
# -------------------------------------------------------
# Set some specific stuff for dumb
# -------------------------------------------------------
if(NOT MSVC)
	set(CFLAGS "-W -O2 -Wwrite-strings -Wstrict-prototypes -Wall -funroll-loops -Wmissing-declarations -fomit-frame-pointer -Wno-missing-declarations")
else(NOT MSVC)
	set(CFLAGS "-O2")
endif(NOT MSVC)

remove_definitions(${CXXFLAGS})
add_definitions(${CFLAGS})

if(MSVC)
	add_definitions("/DDUMB_DECLARE_DEPRECATED")
else(MSVC)
	add_definitions(-DDUMB_DECLARE_DEPRECATED)
endif(MSVC)

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
set(DUMB_SRC
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itorder.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/xmeffect.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itrender.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itread2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itunload.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loadmod.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loads3m.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loadxm2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itload2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/readmod2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/reads3m2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loadmod2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loadxm.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/loads3m2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itload.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itmisc.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/itread.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/readxm.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/readmod.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/reads3m.c
${CMAKE_CURRENT_SOURCE_DIR}/src/it/readxm2.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/makeduh.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/unload.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/loadduh.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/rawsig.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/rendduh.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/rendsig.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/duhlen.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/duhtag.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/atexit.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/readduh.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/register.c
${CMAKE_CURRENT_SOURCE_DIR}/src/core/dumbfile.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/sampbuf.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/stdfile.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/resample.inc
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/clickrem.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/silence.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/resamp2.inc
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/resamp3.inc
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/memfile.c
${CMAKE_CURRENT_SOURCE_DIR}/src/helpers/resample.c
PARENT_SCOPE)

set(UNUSED_DUMB_SRC
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datit.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datxm.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datduh.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datitq.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datmod.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/dats3m.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datxmq.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datmodq.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/dats3mq.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/datunld.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/alplay.c
${CMAKE_CURRENT_SOURCE_DIR}/src/allegro/packfile.c
PARENT_SCOPE)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
include_directories(include include/internal)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (dumb_module ${DUMB_SRC})

# Install
INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include DESTINATION include/r-tech1/libs/dumb)

=== src/libs/gme/CMakeLists.txt ===
# -------------------------------------------------------
# GME cmake build script for r-tech1.
# Written by: juvinious
# -------------------------------------------------------
project (gme C CXX)

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
# GME Library
set(GME_SRC
${CMAKE_CURRENT_SOURCE_DIR}/Ay_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Ay_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Ay_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Blip_Buffer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Classic_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Data_Reader.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Dual_Resampler.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Effects_Buffer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Fir_Resampler.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gb_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gb_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gb_Oscs.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gbs_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/gme.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gme_File.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Gym_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Hes_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Hes_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Hes_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Kss_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Kss_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Kss_Scc_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/M3u_Playlist.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Multi_Buffer.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Music_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Fme7_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Namco_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Oscs.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nes_Vrc6_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nsfe_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Nsf_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Sap_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Sap_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Sap_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Sms_Apu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Snes_Spc.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Spc_Cpu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Spc_Dsp.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Spc_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Spc_Filter.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Vgm_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Vgm_Emu_Impl.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Ym2413_Emu.cpp
${CMAKE_CURRENT_SOURCE_DIR}/Ym2612_Emu.cpp
PARENT_SCOPE)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (gme_module ${GME_SRC})


# Install
file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/r-tech1/libs/gme)

=== src/libs/hawknl/CMakeLists.txt ===
# -------------------------------------------------------
# hawknl cmake build script for r-tech1.
# Written by: juvinious
# -------------------------------------------------------
project (hawknl C CXX)
# -------------------------------------------------------
# Set some specific stuff for hawknl
# -------------------------------------------------------
if(NOT MSVC)
	set(CFLAGS "-W -O2 -Wwrite-strings -Wstrict-prototypes -Wall -funroll-loops -Wmissing-declarations -fomit-frame-pointer -Wno-missing-declarations")
else(NOT MSVC)
	set(CFLAGS "-O2")
endif(NOT MSVC)

remove_definitions(${CXXFLAGS})
add_definitions(${CFLAGS})

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
set(HAWKNL_SRC
${CMAKE_CURRENT_SOURCE_DIR}/src/crc.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/err.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/errorstr.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/group.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/ipx.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/loopback.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/nl.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/nltime.cpp
${CMAKE_CURRENT_SOURCE_DIR}/src/sock.cpp
PARENT_SCOPE)

#${CMAKE_CURRENT_SOURCE_DIR}/src/htcondition.cpp
#${CMAKE_CURRENT_SOURCE_DIR}/src/hthread.cpp
#${CMAKE_CURRENT_SOURCE_DIR}/src/htmutex.cpp

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
#include_directories(include hawknl)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (hawknl_module ${HAWKNL_SRC})

# Install
INSTALL(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/hawknl DESTINATION include/r-tech1/libs/hawknl)

=== src/libs/lz4/CMakeLists.txt ===
# -------------------------------------------------------
# lz4 cmake build script for r-tech1.
# -------------------------------------------------------

project (lz4 C CXX)

# -------------------------------------------------------
# Source directories containing all the necessary .c files
# -------------------------------------------------------
set(LZ4_SRC
${CMAKE_CURRENT_SOURCE_DIR}/lz4.c
PARENT_SCOPE)

# Install
file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/r-tech1/libs/lz4)

=== src/libs/pcre/CMakeLists.txt ===
# -------------------------------------------------------
# PCRE cmake build script for r-tech1.
# Written by: juvinious
# -------------------------------------------------------
project (pcre C CXX)

# -------------------------------------------------------
# Source directories containing all the necessary .c files
# -------------------------------------------------------
# PCRE Library
set(PCRE_SRC
${CMAKE_CURRENT_SOURCE_DIR}/pcre_chartables.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_compile.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_config.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_dfa_exec.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_exec.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_fullinfo.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_get.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_globals.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_info.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_maketables.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_newline.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_ord2utf8.c
${CMAKE_CURRENT_SOURCE_DIR}/pcreposix.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_refcount.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_study.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_tables.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_try_flipped.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_ucd.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_valid_utf8.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_version.c
${CMAKE_CURRENT_SOURCE_DIR}/pcre_xclass.c
PARENT_SCOPE)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (pcre_module ${PCRE_SRC})

# Install
file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/r-tech1/libs/pcre)

=== src/libs/pcre/SConstruct ===
Import('env')

source = Split("""
pcre_chartables.c
pcre_compile.c
pcre_config.c
pcre_dfa_exec.c
pcre_exec.c
pcre_fullinfo.c
pcre_get.c
pcre_globals.c
pcre_info.c
pcre_maketables.c
pcre_newline.c
pcre_ord2utf8.c
pcreposix.c
pcre_refcount.c
pcre_study.c
pcre_tables.c
pcre_try_flipped.c
pcre_ucd.c
pcre_valid_utf8.c
pcre_version.c
pcre_xclass.c
""")

unused = Split("""
dftables.c
pcredemo.c
pcretest.c
""")

x = []
for s in source:
    x.append(env.Object(s))
Return('x')

=== src/libs/sfl/CMakeLists.txt ===
# -------------------------------------------------------
# SFL cmake build script for r-tech1.
# Written by: juvinious
# -------------------------------------------------------
project (sfl C)
# -------------------------------------------------------
# Set some specific stuff for hawknl
# -------------------------------------------------------
if(NOT MSVC)
	set(CFLAGS "-W -O2 -Wwrite-strings -Wstrict-prototypes -Wall -funroll-loops -Wmissing-declarations -fomit-frame-pointer -Wno-missing-declarations")
else(NOT MSVC)
	set(CFLAGS "-O2")
endif(NOT MSVC)

remove_definitions(${CXXFLAGS})
add_definitions(${CFLAGS})

# -------------------------------------------------------
# Source directories containing all the necessary .cpp files
# -------------------------------------------------------
set(SFL_SRC
${CMAKE_CURRENT_SOURCE_DIR}/sflbits.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcomp.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcons.c
${CMAKE_CURRENT_SOURCE_DIR}/sflconv.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcryp.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvbs.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvdp.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvds.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvns.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvsb.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvsd.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvsn.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvtp.c
${CMAKE_CURRENT_SOURCE_DIR}/sflcvts.c
${CMAKE_CURRENT_SOURCE_DIR}/sfldbio.c
${CMAKE_CURRENT_SOURCE_DIR}/sfldir.c
${CMAKE_CURRENT_SOURCE_DIR}/sflenv.c
${CMAKE_CURRENT_SOURCE_DIR}/sflexdr.c
${CMAKE_CURRENT_SOURCE_DIR}/sflfile.c
${CMAKE_CURRENT_SOURCE_DIR}/sflfind.c
${CMAKE_CURRENT_SOURCE_DIR}/sflfort.c
${CMAKE_CURRENT_SOURCE_DIR}/sflhttp.c
${CMAKE_CURRENT_SOURCE_DIR}/sflini.c
${CMAKE_CURRENT_SOURCE_DIR}/sfllang.c
${CMAKE_CURRENT_SOURCE_DIR}/sfllbuf.c
${CMAKE_CURRENT_SOURCE_DIR}/sfllist.c
${CMAKE_CURRENT_SOURCE_DIR}/sflmath.c
${CMAKE_CURRENT_SOURCE_DIR}/sflmem.c
${CMAKE_CURRENT_SOURCE_DIR}/sflmesg.c
${CMAKE_CURRENT_SOURCE_DIR}/sflmime.c
${CMAKE_CURRENT_SOURCE_DIR}/sflnode.c
${CMAKE_CURRENT_SOURCE_DIR}/sflprint.c
${CMAKE_CURRENT_SOURCE_DIR}/sflslot.c
${CMAKE_CURRENT_SOURCE_DIR}/sflstr.c
${CMAKE_CURRENT_SOURCE_DIR}/sflsymb.c
${CMAKE_CURRENT_SOURCE_DIR}/sflsyst.c
${CMAKE_CURRENT_SOURCE_DIR}/sfltok.c
${CMAKE_CURRENT_SOURCE_DIR}/sfltree.c
${CMAKE_CURRENT_SOURCE_DIR}/sfltron.c
${CMAKE_CURRENT_SOURCE_DIR}/sfluid.c
${CMAKE_CURRENT_SOURCE_DIR}/sflxml.c
${CMAKE_CURRENT_SOURCE_DIR}/sfldate.c
PARENT_SCOPE)

# -------------------------------------------------------
# Include directory
# -------------------------------------------------------
include_directories(include ./)

# -------------------------------------------------------
# module
# -------------------------------------------------------
#add_library (sfl_module ${SFL_SRC})

# Install
file(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.h")
INSTALL(FILES ${files} DESTINATION include/r-tech1/libs/sfl)

=== debian/changelog ===
librtech1 (1.0.0-1) groovy; urgency=medium

  * Initial pkging

 -- Chris <dpkg@chris-nz.com>  Mon, 05 Apr 2021 22:19:57 +1200

=== debian/control ===
Source: librtech1
Section: libs
Priority: optional
Maintainer: Chris <dpkg@chris-nz.com>
Build-Depends: cmake (>= 3.5~),
               debhelper-compat (= 12),
               libfreetype-dev,
               liballegro-acodec5-dev,
               liballegro-audio5-dev,
               liballegro-dialog5-dev,
               liballegro-image5-dev,
               liballegro-physfs5-dev,
               liballegro-ttf5-dev,
               liballegro-video5-dev,
               liballegro5-dev,
               libmpg123-dev,
               libogg-dev,
               libpng-dev,
               libvorbis-dev,
               scons,
               zlib1g-dev
Standards-Version: 4.5.0
Homepage: https://github.com/kazzmir/r-tech1
Rules-Requires-Root: no

Package: librtech1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: game development toolkit for c++
 A set of C++ wrappers around existing graphical, music and other libraries.
 .
 This package contains the development headers and files needed to create
 applications that use the r-tech1 library.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
export DEB_CXXFLAGS_MAINT_APPEND = -DQT_NO_DEBUG_OUTPUT -DQT_NO_WARNING_OUTPUT

%:
		dh $@ --buildsystem=cmake


# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
